#include <ESP8266WiFi.h>
#include <MQTT.h>

#define RELAY_PIN 0

const char* ssid = "TP-LINK_401";      // Wi-Fi SSID
const char* password = "20160704";    // Wi-Fi Password

// MQTT info
const char* hostname = "m16.cloudmqtt.com";
int port =10031;//SAME AS WATCH
const char* user = "fvamicuw";//SAME AS WATCH
const char* user_password = "ZvzVfvn_OmUV";//SAME AS WATCH
const char* id = "relay2";

WiFiClient net;
MQTTClient client;

void connect() {
  Serial.print("checking wifi...");
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(1000);
  }

  Serial.print("\nconnecting...");
  while (!client.connect(id, user, user_password)) {
    Serial.print(".");
    delay(1000);
  }

  Serial.println("\nconnected!");

  client.subscribe("/relay");
}

void messageReceived(String &topic, String &payload) {
  Serial.println("incoming: " + topic + " - " + payload);
  if (topic == "/relay") {
    if (payload == "on2") {
      Serial.println("turn on relay");
      digitalWrite(RELAY_PIN, LOW);
    } 
    if (payload == "off2")
    {
      Serial.println("turn off relay");
      digitalWrite(RELAY_PIN, HIGH);
    }
  }
}

void setup() {
  Serial.begin(115200);
  Serial.println("relay on mqtt message bus");

  pinMode(RELAY_PIN, OUTPUT);
  digitalWrite(RELAY_PIN, HIGH);
  WiFi.begin(ssid, password);

  client.begin(hostname, port, net);
  client.onMessage(messageReceived);

  connect();
}

void loop() {
  client.loop();
  delay(10);  // <- fixes some issues with WiFi stability

  if (!client.connected()) {
    connect();
  }
}
